#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Inkey.ch"
#include "DbfDbe.ch"
#include "directry.ch"
#include "OT4XB.ch"
#include "XbZ_Zip.ch"

// zlib1.DLL
// zLib Home Site       => http://www.zlib.net/
// binary download      => * zlib compiled DLL, version 1.2.5,
//                           zipfile format (100K, MD5 checksum 102ba2c232ef5709626db1fdeb53af18):
//                         * US (zlib.net)
// XbZLibZip() 2.00.146 => look in this thread for last URL


procedure main()
   local oZip, cZipBaseDir, cDBF, nMaxRec, x, nLog, nDBF, nCol, nRow, nZeig
   field Feld1,Feld2,Feld3,Feld4
   cls
   set alternate to MyTestLOG.txt
   set alternate on
   ?
   ? time()+" Start"
   ?
   ? time()+" DBE: ",DbeSetDefault()
   ? time()+" DBE: ",DbeInfo( COMPONENT_DATA, DBFDBE_LOCKOFFSET  , 0x7FFFFFFF)," ALT etwa 1 GB"
   ? time()+" DBE: ",DbeInfo( COMPONENT_DATA, DBFDBE_LOCKOFFSET ),             " NEU etwa 2 GB"
   ?
   ?
   ? time()+" XbZLib.DLL-Version: ", XbZ_Version()
   ? time()+" ZLib.DLL-Version:   ", XbZ_ZLibVersion()
   ? time()+" Xbase++ Version:    ", version()+"."+version(3)
   ?
   CreateDir("d:\data")
   CreateDir("d:\data\cust1")
   CreateDir("d:\data\cust1\xyz")
   nDBF := 1
   nLog := 1000
   do while .t.
      do case
         case nDBF=1
              nMaxRec :=    10000
              cDBF := "d:\data\cust1\Dat1.DBF"
         case nDBF=2
              nMaxRec :=   100000
              cDBF := "d:\data\cust1\xyz\Dat2.DBF"
         case nDBF=3
              nMaxRec :=  1000000  //  1 Mio
              cDBF := "d:\data\cust1\xyz\DatBig.DBF"
         case nDBF=4
              nMaxRec := 10000000  // 10 Mio
              cDBF := "d:\data\cust1\xyz\DatBig2.DBF"
         case nDBF=5
              nMaxRec := 16900000  // 18 Mio
              cDBF := "d:\data\cust1\xyz\DatFat.DBF"

         otherwise
              exit
      end

      if ! fexists(cDBF)
         ? time()+" Create "+cDBF
         dbcreate(cDBF, { { "Feld1","c",50,0 } ,;
                          { "Feld2","c",50,0 } ,;
                          { "Feld3","n",18,2 } ,;
                          { "Feld4","d", 8,0 } } )
         use (cDBF) exclusive
         ? time()+" dbappend() until lastrec()=",transform(nMaxRec,"999,999,999,999"),"=>"
         nCol := col()
         nRow := row()
         nLog := 1000
         nZeig := 0
         do while lastrec() < nMaxRec
             dbappend()
             if neterr()
                ? "NETERR() = ",cDBF
                quit
             endif
             x := recno()
             replace feld1 with "Feld 1 in record: "+str(x,12,0)
             replace feld2 with "Feld 2 in record: "+str(x,12,0)
             replace feld3 with x
             replace feld4 with date()
             if int(x/nLog) == x/nLog
                nZeig++
                @ nRow,nCol say x picture "999,999,999,999"
             endif
         enddo
         ? "     ==> OK, Lastrec()=",transform(Lastrec(),"999,999,999,999")
         close
         ?? "    Byte: "+transform(FSize(cDBF),"999,999,999,999")
         ?
      endif
      nDBF++
   enddo

   ? time()+" Create 1. ZIP"

   cZipBaseDir := "d:\data\cust1\"

   oZip := XbZLibZip():New("d:\data\cust1\Data1.ZIP")
   if oZip:IsOpen(.t.)
      oZip:AddFile("Dat1.DBF",     cZipBaseDir)
      oZip:AddFile("xyz\Dat2.DBF", cZipBaseDir)
   endif
   oZip:Close()
   ?? " Byte: "+transform(FSize("d:\data\cust1\Data1.ZIP"),"999,999,999,999")
   ?
   ? time()+" Create 2. ZIP"
   oZip := XbZLibZip():New("d:\data\cust1\Data2.ZIP")
   if oZip:IsOpen(.t.)
      oZip:AddDir("*.DBF", cZipBaseDir, ,.t.,.t.)
   endif
   oZip:Close()
   ?? " Byte: "+transform(FSize("d:\data\cust1\Data2.ZIP"),"999,999,999,999")
   ?
   ? time()+" Create 3. ZIP"
   oZip := XbZLibZipHB():New("d:\data\cust1\DataHB.ZIP")
   if oZip:IsOpen(.t.)
      oZip:AddDir("*.DBF", cZipBaseDir, ,.t.,.t.,.t.)
   endif
   oZip:Close()
   ?? " Byte: "+transform(FSize("d:\data\cust1\DataHB.ZIP"),"999,999,999,999")
   ?
   ? time()+" End in 10 seconds or press key"
   inkey(10)

return

Class XbZLibZipHB from XbZLibZip
    EXPORTED:
    Method AddDir    // Replace original !
EndClass

// OLD cRootdir      -> cRootDir\Files ... ZIP is only OK, if the call is from curdir()
// NEW cRootdir      -> cRootDirZIP -> ::addFile(cRootDirZIP+filename)
// NEW cRootDirFiles -> aFiles := directory( cRootDirFiles + cFileSpec )

Method XbZLibZipHB:AddDir(cFileSpec, cRootDirZIP, cAttribs, lSubDirs, lAddPath, lAddNote, cRootDirFiles )
LOCAL cFSpec := iif(cFileSpec == NIL, '*.*', cFileSpec)
LOCAL cAttr  := iif(cAttribs  == NIL, 'AHS', upper(cAttribs))
LOCAL lSubs  := iif(lSubDirs  == NIL, .f.,   lSubDirs) .or. 'D' $ cAttr
LOCAL lPath  := iif(lAddPath  == NIL, .f.,   lAddPath) .or. lSubs
LOCAL lText  := iif(lAddNote  == NIL, .f.,   lAddNote)
LOCAL nQuit  := XBZ_DONT_QUIT
LOCAL aFiles
local x, nMax

     if ::IsOpen(.t.)
        // cRootDirFiles will serve directory()
        if empty(cRootDirFiles)       // could be "" or NIL -> no info about the files dir ?
           if "\" $ ::FileName
              cRootDirFiles := cPathGetPath(::FileName)   // if possible, think that the ZIP is in the same directory
           else
              cRootDirFiles := CurDrive() + ':\' + CurDir(CurDrive()) + '\' // or take the current ...
           endif
        else
           cRootDirFiles := strTran(cRootDirFiles,"/","\")
           if cRootDirFiles[-1] # '\'
              cRootDirFiles += '\'
           endif
        endif
        // cRootDirZIP will define the basedir in ZIP file
        if empty(cRootDirZIP)       // could be "" or NIL
           cRootDirZIP := ""
        else
           cRootDirZIP := strTran(cRootDirZIP,"/","\")
           if cRootDirZIP[-1] # '\'
              cRootDirZIP += '\'
           endif
           x := len(cRootDirFiles)
           if upper(left(cRootDirZIP,x)) == upper(cRootDirFiles)
              cRootDirZIP := substr(cRootDirZIP,x+1)
           endif
        endif

        if lSubs
           if At('D', cAttr) == 0
              cAttr += 'D'
           endif

           aFiles := Directory(cRootDirFiles + cRootDirZIP + '*.*', cAttr)
           aFiles := ASort(aFiles, , , {|a, b| upper(a[F_NAME]) < upper(b[F_NAME])})
           nMax  := len(aFiles)

           if ::lDisplay .and. .not. ::IsConsole
              ::Display('Reading Sub-Directories from "' + cRootDirFiles + '"...')
           endif
           // first walk through the subdirs, but don't build them, if there are files, they will build the dirs too.
           for x := 1 to nMax
               if 'D' $ aFiles[x, F_ATTR] .and. .not. (aFiles[x, F_NAME] == '.' .or. aFiles[x, F_NAME] == '..')
                  // make debugging easy, and don't care about empty dirs !
                  if ::EventLoop()
                     nQuit := ::CancelAdd(cRootDirFiles + aFiles[x, F_NAME], .t.)
                     if nQuit # XBZ_DONT_QUIT
                        return (nQuit)
                     endif
                  endif
                  nQuit := ::AddDir(cFSpec, cRootDirZIP + aFiles[x, F_NAME], cAttr, lSubs, lPath, lText, cRootDirFiles  )
                endif
                if nQuit == XBZ_QUIT_ALL
                    return (nQuit)
                elseif nQuit == XBZ_QUIT_CURRENT
                    exit
                endif
            next
        endif

        if ::lDisplay .and. .not. ::IsConsole
            ::Display('Reading Files from Directory "' + cRootDirFiles + '"...')
        endif

        aFiles := Directory(cRootDirFiles + cRootDirZIP + cFSpec , strTran(cAttr,"D",""))
        aFiles := ASort(aFiles, , , {|a, b| upper(a[F_NAME]) < upper(b[F_NAME])})
        nMax   := len(aFiles)

        for x := 1 to nMax
            if ::EventLoop()
               nQuit := ::CancelAdd(cRootDirFiles + aFiles[x, F_NAME], .t.)
               if nQuit # XBZ_DONT_QUIT
                  return (nQuit)
               endif
            endif
            // cRootDirZIP could be empty, this is needed because of maybe empty dirs.
            nQuit := ::AddFile(cRootDirZIP + aFiles[x, F_NAME], cRootDirFiles ,;
                                             iif(lText,cRootDirZip+aFiles[x, F_NAME] ,''), lText )
            if nQuit # XBZ_OK
               return (XBZ_QUIT_CURRENT)
               exit
            endif
        next

     endif
return (nQuit)


